From 43c58a7a48814653a6f40d759c419aeb163b6ac2 Mon Sep 17 00:00:00 2001
From: Akash Mehrotra <mehrotra.akash@gmail.com>
Date: Sun, 24 Apr 2011 15:01:01 +0530
Subject: [PATCH] Added Force pause, force resume
 Updated pl_pause to behave as in oldhttp

---
 share/lua/http/requests/README.txt |    8 +++++++-
 share/lua/http/requests/status.xml |   18 +++++++++++++++++-
 2 files changed, 24 insertions(+), 2 deletions(-)

diff --git a/share/lua/http/requests/README.txt b/share/lua/http/requests/README.txt
index c287acf..f3a7667 100644
--- a/share/lua/http/requests/README.txt
+++ b/share/lua/http/requests/README.txt
@@ -26,9 +26,15 @@ status.xml:
 > play playlist item <id>. If <id> is omitted, play last active item:
   ?command=pl_play&id=<id>
 
-> toggle pause. If current state was 'stop', play item <id>:
+> toggle pause. If current state was 'stop', play item <id>, if no <id> specified, play current item. If no current item, play 1st item in the playlist:
   ?command=pl_pause&id=<id>
 
+> resume playback if paused, else do nothing
+  ?command=pl_forceresume
+
+> pause playback, do nothing if already paused
+  ?command=pl_forcepause
+
 > stop playback:
   ?command=pl_stop
 
diff --git a/share/lua/http/requests/status.xml b/share/lua/http/requests/status.xml
index 944cf09..bbef12d 100644
--- a/share/lua/http/requests/status.xml
+++ b/share/lua/http/requests/status.xml
@@ -59,7 +59,23 @@ elseif command == "pl_play" then
     vlc.playlist.goto(id)
   end
 elseif command == "pl_pause" then
-  vlc.playlist.pause()
+  if vlc.playlist.status() == "stopped" then
+    if id == -1 then
+      vlc.playlist.play()
+    else
+      vlc.playlist.goto(id)
+    end
+  else
+    vlc.playlist.pause()
+  end
+elseif command == "pl_forcepause" then
+  if vlc.playlist.status() == "playing" then
+    vlc.playlist.pause()
+  end
+elseif command == "pl_forceresume" then
+  if vlc.playlist.status() == "paused" then
+    vlc.playlist.pause()
+  end
 elseif command == "pl_stop" then
   vlc.playlist.stop()
 elseif command == "pl_next" then
-- 
1.7.1

